//
// File: CImage.cc
// Created by: User <Email>
// Created on: Wed Mar  2 11:18:31 2005
//

#include "CImage.h"


CImage::CImage()
{
  gray=0;
  R=G=B=0;
  width=0;
  height=0;
}


CImage::~CImage()
{
  Delete();
}

void CImage::Delete()
{
	  if (gray) delete []gray;
	  if (R) delete []R;
	  if (G) delete []G;
	  if (B) delete []B;

}
void CImage::ReadPPM(char *name)
{
	
  FILE *fin=fopen(name,"r");
  char buf[1000];
  fgets(buf,999,fin);	/* 1. line */	
  fgets(buf,999,fin);	/* 2. line */	
 
  fscanf(fin,"%d%d%d",&width,&height,&maxcolor);
  R=new int[width*height];	  
  G=new int[width*height];	  
  B=new int[width*height];	  
  int i,j,k;
  k=0;
  for (j=0;j<height;j++)
	for (i=0;i<width;i++,k++)
	  {
		fscanf(fin,"%d",&R[k]);
		fscanf(fin,"%d",&G[k]);
		fscanf(fin,"%d",&B[k]);
      }
	fclose(fin);	
	
}

void CImage::WritePPM(char *name)
{
  FILE *fout=fopen(name,"w");
	
	fprintf(fout,"P3\n# CREATOR: Martin\n");
	fprintf(fout,"%d %d\n%d\n",width,height,maxcolor);
	
	int i,j,k;
	k=0;
    for (j=0;j<height;j++)
	 for (i=0;i<width;i++,k++)
	  {
		fprintf(fout,"%d %d %d\n",R[k],G[k],B[k]);
	  }
  fclose(fout);	
	
}

void CImage::WriteGrayPPM(char *name)
{
  if (!gray) ConvertToGray();
  FILE *fout=fopen(name,"w");
	
	fprintf(fout,"P2\n# CREATOR: Martin\n");
	fprintf(fout,"%d %d\n%d\n",width,height,maxcolor);
	
	int i,j,k;
    k=0;
    for (j=0;j<height;j++)
	 for (i=0;i<width;i++,k++)
	  {
		fprintf(fout,"%d\n",gray[k]);
	  }
  fclose(fout);	
	
}


int CImage::GetWidth()
{
	return width;
}
int CImage::GetHeight()
{
	return height;
}
int CImage::GetMaxcolor()
{
	return maxcolor;
}
void CImage::ConvertToGray()
{
	if (gray) delete []gray;
	gray= new int [width*height];
	int i,j;
	for (i=0;i<width;i++)
	  for (j=0;j<height;j++)
	  {
//		gray[IDX(i,j)]=255-(int) (.299 *(255.-(double)R[IDX(i,j)]) +
//					  .587*(255.-(double)G[IDX(i,j)])+
//					  .114*(255.-(double)B[IDX(i,j)]));
//		gray[IDX(i,j)]=(int) (.299 *(double)R[IDX(i,j)] +
//					  .587*(double)G[IDX(i,j)]+
//					  .114*(double)B[IDX(i,j)]);
		gray[IDX(i,j)]=(299 *R[IDX(i,j)] +
					  587*G[IDX(i,j)]+
					  114*B[IDX(i,j)])/1000;
	  }
}
